VERSION 5.00
Begin VB.Form frmChild 
   Caption         =   "Form1"
   ClientHeight    =   4470
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4905
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   4470
   ScaleWidth      =   4905
   WindowState     =   2  'Maximized
   Begin VB.TextBox txtDocument 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2895
      Left            =   0
      MultiLine       =   -1  'True
      OLEDropMode     =   1  'Manual
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   4695
   End
   Begin VB.TextBox Text1 
      Height          =   1215
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      Text            =   "frmChild.frx":0000
      Top             =   3240
      Visible         =   0   'False
      Width           =   4695
   End
   Begin VB.Label lblStatus 
      Alignment       =   1  'Right Justify
      Caption         =   "1 - 1"
      Height          =   375
      Left            =   0
      OLEDropMode     =   1  'Manual
      TabIndex        =   1
      Top             =   2880
      Width           =   4695
   End
End
Attribute VB_Name = "frmChild"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------------------
'- DomPad editor                                               ---------
'- Dominique LIARD - liard@infini-fr.com                       ---------
'- Exemple disponible  partir de http://www.infini-fr.com     ---------
'-----------------------------------------------------------------------

Option Explicit

Private mblnModified As Boolean
Private mstrFilename As String
Private history As New TextComponentHistory

'-Pour grer les Undo et le redos--------------------
Public fromUndoRedoButtons As Boolean

Private Sub Form_Activate()
    Me.ChangeCaption (Me.Caption)
End Sub

Private Sub Form_Load()

    Me.isModified = False
    Me.filename = ""
    Me.Caption = "Untitled"
    
    'history.addState (Me.Controls(0))
End Sub

Private Sub Form_Unload(Cancel As Integer)
    frmMain.Caption = "DomPad"
End Sub

Public Property Get isModified() As Boolean
    isModified = mblnModified
End Property

Public Property Let isModified(state As Boolean)
    mblnModified = state
End Property

Public Property Get filename() As String
    filename = mstrFilename
End Property

Public Property Let filename(name As String)
    mstrFilename = name
End Property

Public Property Get text() As String
    text = txtDocument.text
End Property

Private Sub Form_KeyPress(KeyAscii As Integer)
    Me.isModified = True
End Sub

'-Gestion de la position du curseur------------------
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    Dim subString As String, X As Integer, Y As Integer
    
    subString = Left(txtDocument, txtDocument.SelStart)
    X = 1
    Y = 1
    
    Dim i As Integer
    For i = 1 To txtDocument.SelStart
        Dim char As String
        char = Mid(subString, i, 1)
        
        If char = vbCr Then
            X = 1
            Y = Y + 1
        ElseIf Asc(char) > 31 Then
            X = X + 1
        End If
    Next

    lblStatus.Caption = X & " - " & Y
End Sub

Private Sub txtDocument_Click()
    Form_KeyUp 0, 0
End Sub

'------------------------------------------------------------------
'-Gestion du UNDO et du REDO---------------------------------------
'------------------------------------------------------------------
Private Sub txtDocument_Change()
    'Dim state As Boolean
    'state = Me.fromUndoRedoButtons
    'Me.fromUndoRedoButtons = False
    'If state = True Then Exit Sub

    'history.addState (Me.Controls(0))
    frmMain.mnuUndo.Enabled = True
    frmMain.mnuRedo.Enabled = True
End Sub

Public Sub undo()
    'Me.fromUndoRedoButtons = True
    'history.back (Me.Controls(0))
End Sub

'-Demande de sortie du logiciel---------
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If Me.isModified Then
        Dim frmQuit As New frmCloseWindow
        Dim res As QuitState
        frmQuit.Caption = Me.Caption
        frmQuit.Show (vbModal)
        res = frmQuit.exitCode
        Select Case res
            Case domQuitAndSave
                frmMain.forcedSave
                If Me.isModified Then Cancel = True
            Case domQuit
                'Cancel = False
                Unload Me
            Case domCancel
                Cancel = True
        End Select
        
        Unload frmQuit
        Set frmQuit = Nothing
    End If
End Sub

Private Sub Form_Resize()
    If Me.WindowState = vbMinimized Then Exit Sub

    txtDocument.Width = Me.Width - 100
    txtDocument.Height = Me.Height - 600

    lblStatus.Width = Me.Width - 150
    lblStatus.Top = txtDocument.Top + txtDocument.Height + 10
End Sub

Public Sub LoadFile(filename As String)
    Dim fileSystem As New FileSystemObject, openFile As TextStream

    Set openFile = fileSystem.OpenTextFile(filename, ForReading)
    Dim content As String
    
    Do While Not openFile.AtEndOfStream
        content = content & openFile.ReadLine
        content = content & vbCrLf
    Loop
    openFile.Close
    txtDocument.text = content
    
    Set openFile = Nothing
    Set fileSystem = Nothing
    
    Set history = Nothing
    Set history = New TextComponentHistory
    history.addState txtDocument
End Sub

Public Sub SaveFile(filename As String)
    Dim fileSystem As New FileSystemObject, theFile As TextStream

    Set theFile = fileSystem.CreateTextFile(filename, True)
    theFile.WriteLine Me.text
    theFile.Close
    
    Set theFile = Nothing
    Set fileSystem = Nothing
    
    Me.isModified = False
End Sub

Public Sub ChangeCaption(strCaption As String)
    frmMain.Caption = strCaption & " - DomPad"
    Me.Caption = strCaption
End Sub


Private Sub txtDocument_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Forms(0).MDIForm_OLEDragDrop Data, Effect, Button, Shift, X, Y
End Sub

Private Sub lblStatus_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Forms(0).MDIForm_OLEDragDrop Data, Effect, Button, Shift, X, Y
End Sub

Private Sub Form_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Forms(0).MDIForm_OLEDragDrop Data, Effect, Button, Shift, X, Y
End Sub


