VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TextComponentHistory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-----------------------------------------------------------------------
'- DomPad editor                                               ---------
'- Dominique LIARD - liard@infini-fr.com                       ---------
'- Exemple disponible  partir de http://www.infini-fr.com     ---------
'-----------------------------------------------------------------------
Option Explicit

' Permet de contenir un tat pour un composant de text
Private Type Modif
    content As String
    pos As Integer
End Type

' Quelques attributs
Private Const mintBuffersSizeMax = 5
Private buffers(mintBuffersSizeMax - 1) As Modif
Private mintBuffersPos As Integer
Private mintBuffersSize As Integer

' Initilisation de l'objet
Private Sub Class_Initialize()
    mintBuffersPos = -1
    mintBuffersSize = 0
End Sub

' Permet de revenir  la modification prcdente
Public Sub back(textComponent As VB.TextBox)
    If mintBuffersSize = 1 Then Exit Sub
    mintBuffersPos = mintBuffersPos - 1
    If mintBuffersPos < 0 Then
        mintBuffersPos = mintBuffersSizeMax - 1
    End If
    textComponent.text = buffers(mintBuffersPos).content
    textComponent.SelStart = buffers(mintBuffersPos).pos
    
    mintBuffersSize = mintBuffersSize - 1
End Sub

'Permet de revenir  la modificatio suivante
Public Sub forward(textComponent As VB.TextBox)

End Sub

' Ajout un nouvel tat  l'historique des modiications
Public Sub addState(textComponent As VB.TextBox)
    Dim state As Modif
    state.content = textComponent.text
    state.pos = textComponent.SelStart
    
    mintBuffersPos = mintBuffersPos + 1
    If mintBuffersPos >= mintBuffersSizeMax Then
        mintBuffersPos = 0
    End If
    
    buffers(mintBuffersPos) = state
    mintBuffersSize = mintBuffersSize + 1
    If mintBuffersSize > mintBuffersSizeMax Then
        mintBuffersSize = mintBuffersSizeMax
    End If
End Sub


