VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.MDIForm frmMain 
   BackColor       =   &H8000000C&
   Caption         =   "DomPad"
   ClientHeight    =   5565
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   7335
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "MDIForm1"
   OLEDropMode     =   1  'Manual
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cmnDialogs 
      Left            =   120
      Top             =   4440
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuLoad 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "Save &as"
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
         Shortcut        =   ^Q
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuUndo 
         Caption         =   "&Undo"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuRedo 
         Caption         =   "&Redo"
         Enabled         =   0   'False
         Visible         =   0   'False
      End
      Begin VB.Menu mnuSep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuCut 
         Caption         =   "Cu&t"
      End
      Begin VB.Menu mnuCopy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu mnuPaste 
         Caption         =   "&Paste"
      End
      Begin VB.Menu mnuSep4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSelectAll 
         Caption         =   "Select &All"
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuSep5 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFind 
         Caption         =   "&Find"
         Shortcut        =   ^F
      End
      Begin VB.Menu mnuFindNext 
         Caption         =   "Find &next"
         Shortcut        =   {F3}
      End
      Begin VB.Menu mnuReplace 
         Caption         =   "&Replace"
         Shortcut        =   ^H
      End
   End
   Begin VB.Menu mnuTools 
      Caption         =   "&Tools"
      Visible         =   0   'False
      Begin VB.Menu mnuWordCounter 
         Caption         =   "Word Counter (wc)"
         Shortcut        =   +^{F1}
      End
   End
   Begin VB.Menu mnuWindow 
      Caption         =   "&Window"
      WindowList      =   -1  'True
      Begin VB.Menu mnuTileH 
         Caption         =   "Tile &Horizontally"
      End
      Begin VB.Menu mnuTileV 
         Caption         =   "Tile &Verticaly"
      End
      Begin VB.Menu mnuCascade 
         Caption         =   "&Cascade"
      End
      Begin VB.Menu mnuArrange 
         Caption         =   "&Arrange icons"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuabout 
         Caption         =   "&About ..."
      End
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "&Popup"
      Visible         =   0   'False
      Begin VB.Menu mnuNew1 
         Caption         =   "&New"
      End
      Begin VB.Menu mnuExit2 
         Caption         =   "&Exit"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------------------
'- DomPad editor                                               ---------
'- Dominique LIARD - liard@infini-fr.com                       ---------
'- Exemple disponible  partir de http://www.infini-fr.com     ---------
'-----------------------------------------------------------------------
Option Explicit

Private Function FindFilename(path As String) As String
    Dim length As Integer, pos As Integer, char As String
    length = Len(path)
    pos = length
    
    Do
        char = Mid(path, pos, 1)
        If char = "\" Or pos = 1 Then Exit Do
        pos = pos - 1
    Loop
    FindFilename = Mid(path, pos + 1, length - pos)
End Function

Private Sub MDIForm_Activate()
    Dim parameters() As String, i As Integer
    Dim res As Boolean
    res = parseCommandLine(parameters)   ' parameters est un param en Output
    
    If res <> True Then
        'frmChild.Show
        'frmChild.Caption = "Untitled"
    Else
        For i = LBound(parameters) To UBound(parameters) - 1
            'MsgBox (parameters(i))
            LoadFile parameters(i), FindFilename(parameters(i))
        Next
    End If
    
End Sub

Private Sub MDIForm_Load()
    Me.Top = GetSetting("DomPad", "IHM", "Top", Me.Top)
    Me.Left = GetSetting("DomPad", "IHM", "Left", Me.Left)
    Me.Width = GetSetting("DomPad", "IHM", "Width", Me.Width)
    Me.Height = GetSetting("DomPad", "IHM", "Height", Me.Height)
    Me.WindowState = GetSetting("DomPad", "IHM", "WindowState", Me.WindowState)
End Sub

Private Sub MDIForm_Unload(Cancel As Integer)
    If Me.WindowState <> vbMaximized Then
        SaveSetting "DomPad", "IHM", "Top", Me.Top
        SaveSetting "DomPad", "IHM", "Left", Me.Left
        SaveSetting "DomPad", "IHM", "Width", Me.Width
        SaveSetting "DomPad", "IHM", "Height", Me.Height
    End If
    
    SaveSetting "DomPad", "IHM", "WindowState", Me.WindowState
End Sub

Private Sub MDIForm_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then
        Me.PopupMenu mnuPopup
    End If
End Sub

Public Sub MDIForm_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim files, i
    For Each i In Data.files
        LoadFile CStr(i), FindFilename(CStr(i))
    Next
End Sub

Private Sub mnuabout_Click()
    Dim dialogBox As New frmAbout
    dialogBox.Show vbModal
End Sub

Private Sub mnuArrange_Click()
    Me.Arrange vbArrangeIcons
End Sub

Private Sub mnuCascade_Click()
    Me.Arrange vbCascade
End Sub

Private Sub mnuCut_Click()
    Clipboard.SetText Me.ActiveForm.txtDocument.SelText
    Me.ActiveForm.txtDocument.SelText = ""
End Sub

Private Sub mnuCopy_Click()
    Clipboard.SetText Me.ActiveForm.txtDocument.SelText, vbCFText
End Sub

Private Sub mnuExit2_Click()
    Unload Me
End Sub

Private Sub mnuNew1_Click()
    mnuNew_Click
End Sub

Private Sub mnuPaste_Click()
    Me.ActiveForm.txtDocument.SelText = Clipboard.GetText
End Sub

Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub mnuLoad_Click()
    cmnDialogs.ShowOpen
    If cmnDialogs.filename = "" Then Exit Sub
    
    LoadFile cmnDialogs.filename, cmnDialogs.fileTitle
    cmnDialogs.filename = ""
End Sub
        
Private Sub LoadFile(filename As String, fileTitle As String)
    Dim activeWindow
    Set activeWindow = Me.ActiveForm
    
    Dim blnCreateWindow As Boolean
    blnCreateWindow = False
    
    If TypeName(activeWindow) = "Nothing" Then
        blnCreateWindow = True
    Else
        If activeWindow.text <> "" Or _
           activeWindow.isModified = True Then
            blnCreateWindow = True
        End If
    End If
    
    If blnCreateWindow Then
        Dim frmChildNew As New frmChild
        Load frmChildNew
        frmChildNew.Show
        Set activeWindow = frmChildNew
    End If
    
    activeWindow.LoadFile (filename)
    activeWindow.ChangeCaption (fileTitle)
    activeWindow.filename = filename
End Sub

Private Sub mnuNew_Click()
    Dim frmChildNew As New frmChild
    Load frmChildNew
    frmChildNew.Show
End Sub

Private Sub mnuSave_Click()
    Dim activeWindow
    Set activeWindow = Me.ActiveForm
    If TypeName(activeWindow) = "Nothing" Then Exit Sub
    
    If activeWindow.filename <> "" Then
        activeWindow.SaveFile (activeWindow.filename)
    Else
        mnuSaveAs_Click
    End If
End Sub

Private Sub mnuSaveAs_Click()
    Dim activeWindow
    Set activeWindow = Me.ActiveForm
    If TypeName(activeWindow) = "Nothing" Then Exit Sub
    
    cmnDialogs.ShowSave
    If cmnDialogs.filename = "" Then Exit Sub
    
    activeWindow.SaveFile (cmnDialogs.filename)
    activeWindow.ChangeCaption (cmnDialogs.fileTitle)
    activeWindow.filename = cmnDialogs.filename

    cmnDialogs.filename = ""

End Sub

Private Sub mnuSelectAll_Click()
    Dim activeWindow As frmChild
    Set activeWindow = Me.ActiveForm
    If TypeName(activeWindow) = "Nothing" Then Exit Sub
    
    activeWindow.txtDocument.SelStart = 0
    activeWindow.txtDocument.SelLength = Len(activeWindow.txtDocument.text)
End Sub

Private Sub mnuFind_Click()
    Dim frmFind As New frmFindReplace
    frmFind.mode = domFind
    frmFind.Show vbModal
    Unload frmFind
    Set frmFind = Nothing
End Sub

Private Sub mnuReplace_Click()
    Dim frmFind As New frmFindReplace
    frmFind.mode = domReplace
    frmFind.Show vbModal
    Unload frmFind
    Set frmFind = Nothing

End Sub

Public Sub forcedSave()
    mnuSave_Click
End Sub

Private Sub mnuTileH_Click()
    Me.Arrange vbTileHorizontal
End Sub

Private Sub mnuTileV_Click()
    Me.Arrange vbTileVertical
End Sub

Private Sub mnuUndo_Click()
    Dim activeWindow As frmChild
    Set activeWindow = Me.ActiveForm
    If TypeName(activeWindow) = "Nothing" Then Exit Sub
    
    activeWindow.undo
End Sub

Private Sub mnuRedo_Click()
    Dim activeWindow As frmChild
    Set activeWindow = Me.ActiveForm
    If TypeName(activeWindow) = "Nothing" Then Exit Sub
    
    activeWindow.fromUndoRedoButtons = True
End Sub

Private Function parseCommandLine(parameters() As String)
    
    Dim commandLine As String
    commandLine = Command()
    If commandLine = "" Then
        parseCommandLine = False
        Exit Function
    End If
    
    ReDim parameters(10)
    Dim counter As Integer, i As Integer, inQuote As Boolean, theChar, lenght As Integer
    counter = 0
    inQuote = False
    lenght = Len(commandLine) - 1
    
    For i = 0 To lenght
        theChar = Mid(commandLine, i + 1, 1)
        If inQuote Then
            If theChar <> """" Then
                parameters(counter) = parameters(counter) + theChar
            Else
                If (i < lenght) Then
                    counter = counter + 1
                    i = i + 1
                End If
                inQuote = False
            End If
        Else
            If theChar = """" Then
                inQuote = True
            ElseIf theChar = " " Then
                counter = counter + 1
            Else
                parameters(counter) = parameters(counter) + theChar
            End If
        End If
    Next
    
    ReDim Preserve parameters(counter + 1)
    parseCommandLine = True
End Function

